package test;

import static javax.ejb.TransactionAttributeType.SUPPORTS;
import static javax.ejb.TransactionManagementType.CONTAINER;

import javax.annotation.PostConstruct;
import javax.annotation.Resource;
import javax.ejb.Remote;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionManagement;

@Stateless
@Remote(TestSelfRef.class)
@TransactionManagement(CONTAINER)
public class TestSelfRefBean implements TestSelfRef
{
  @Resource private SessionContext sc;
  private TestSelfRef self;

  @TransactionAttribute(SUPPORTS) 
  public void method1()
  {
    System.out.println("\n\n");
    System.out.println("Execute method1() ENTER");
    self.method2();
    System.out.println("Execute method1() EXIT");
  }

  @TransactionAttribute(SUPPORTS) 
  public void method2()
  {
    System.out.println("Execute method2() ENTER/EXIT");
  }
  
  @PostConstruct private void postConstruct()
  {
    System.out.println("Execute postConstruct() ENTER");
    self = sc.getBusinessObject(TestSelfRef.class);
    System.out.println("Execute postConstruct() EXIT");
  }
}
